/***********************ͷļ****************************/
#include "main.h"
#include "sys.h"
#include "delay.h"
#include "led.h"
#include "exti.h"
#include "includes.h"
#include "timer.h"

/***********************ָ****************************/
OS_EVENT * sem_TaskC;    //Cźָ
OS_EVENT * sem_Mutex;    //ź
OS_EVENT * q_Msg;    //Ϣ
void * MsgGrp[256];   //Ϣд洢ַ֧256Ϣ

/***********************ȫֱ****************************/
u16 *I3_Num;
static u16 I3_InNum;    // 洢Ϣ
u32 PB4_Num;    //洢
u8 flag_Exit;   //ִажϱ־λ
uint8_t taskA_Num = 0 ;//¼AС˸

/**********************START ****************************/
#define START_TASK_PRIO			3  //ʼȼ
#define START_STK_SIZE			128  //ջС
OS_STK START_TASK_STK[START_STK_SIZE];//ջ
void start_task(void *pdata);//

/**********************A*********************************/
#define LEDA_TASK_PRIO			4  //ȼ
#define LEDA_STK_SIZE			128  //ջС
OS_STK LEDA_TASK_STK[LEDA_STK_SIZE];  //ջ
void ledA_task(void *pdata);  //

/**********************B********************************/
#define LEDB_TASK_PRIO			5  //ȼ
#define LEDB_STK_SIZE			128  //ջС
OS_STK LEDB_TASK_STK[LEDB_STK_SIZE];  //ջ
void ledB_task(void *pdata);  //

/**********************C********************************/
#define LEDC_TASK_PRIO			6  //ȼ
#define LEDC_STK_SIZE			128  //ջС
OS_STK LEDC_TASK_STK[LEDC_STK_SIZE]; //ջ
void ledC_task(void *pdata);  //

/**********************D********************************/
#define LEDD_TASK_PRIO			9  //ȼ
#define LEDD_STK_SIZE			128  //ջС
OS_STK LEDD_TASK_STK[LEDD_STK_SIZE];  //ջ
void ledD_task(void *pdata);  //

/*********************E********************************/
#define LEDE_TASK_PRIO			10  //ȼ
#define LEDE_STK_SIZE			128  //ջС
OS_STK LEDE_TASK_STK[LEDE_STK_SIZE];  //ջ
void ledE_task(void *pdata);  //

/*********************F ********************************/
#define LEDF_TASK_PRIO			7  //ȼ
#define LEDF_STK_SIZE			128  //ջС
OS_STK LEDF_TASK_STK[LEDF_STK_SIZE];  //ջ
void ledF_task(void *pdata);  // 

/************************************************/
#define KEYG_TASK_PRIO			11  //ȼ
#define KEYG_STK_SIZE			128  //ջС
OS_STK KEYG_TASK_STK[KEYG_STK_SIZE];  //ջ
void keyG_task(void *pdata);  //


/************************************************/
int main(void)
{
    
    HSI_SetSysClock(16, 336, 2, 7); //ʹHSIϵͳʱΪ168M  
    TIM3_Int_Init(4999, 8399);  //ʱӳʼ
	delay_init(168);       //ʱʼ
	NVIC_PriorityGroupConfig(NVIC_PriorityGroup_2); //жϷ
	LED_Init();  //LEDʼ
    EXTIX_Init();	//ⲿжϳʼ	
	OSInit();  //UCOSʼ
	OSTaskCreate(start_task, (void*)0, (OS_STK*)&START_TASK_STK[START_STK_SIZE-1], START_TASK_PRIO); //ʼ
	OSStart(); //ʼ
}

/******************************************************
//UCOSʼ
//ṩʼź䡢Ϣ
ź񡢳ʼͳȵ
********************************************************/
void start_task(void *pdata)
{
    OS_CPU_SR cpu_sr = 0;
    pdata=pdata;
    u8 err; //־
    sem_TaskC = OSSemCreate(0); //ź
    msg_TaskC = OSMboxCreate((void*) 0);//Ϣ
    sem_Mutex = OSMutexCreate(8, &err);    //ź ȼΪ8
    q_Msg = OSQCreate(&MsgGrp[0],256);  //Ϣ
	OSStatInit();  //ͳ	
	OS_ENTER_CRITICAL();  //ٽ(رж)
    OSTaskCreate(ledA_task,(void*)0,(OS_STK*)&LEDA_TASK_STK[LEDA_STK_SIZE-1],LEDA_TASK_PRIO);//A
    OSTaskCreate(ledB_task,(void*)0,(OS_STK*)&LEDB_TASK_STK[LEDB_STK_SIZE-1],LEDB_TASK_PRIO);//B
    OSTaskCreate(ledC_task,(void*)0,(OS_STK*)&LEDC_TASK_STK[LEDC_STK_SIZE-1],LEDC_TASK_PRIO);//C
    OSTaskCreate(ledD_task,(void*)0,(OS_STK*)&LEDD_TASK_STK[LEDD_STK_SIZE-1],LEDD_TASK_PRIO);//D
    OSTaskCreate(ledE_task,(void*)0,(OS_STK*)&LEDE_TASK_STK[LEDE_STK_SIZE-1],LEDE_TASK_PRIO);//E
    OSTaskCreate(ledF_task,(void*)0,(OS_STK*)&LEDF_TASK_STK[LEDF_STK_SIZE-1],LEDF_TASK_PRIO);//F
    OSTaskCreate(keyG_task,(void*)0,(OS_STK*)&KEYG_TASK_STK[KEYG_STK_SIZE-1],KEYG_TASK_PRIO);//G
    OSTaskSuspend(START_TASK_PRIO);//ʼ  
    OS_EXIT_CRITICAL();  //˳ٽ(ж)
}
 
/********************A****************************
1. AС1HzƵ˸
2. AС˸10ιABִ
*************************************************************/
void ledA_task(void *pdata)
{
    pdata=pdata;
    NVIC_InitTypeDef   NVIC_InitStructure;
	while(1)
	{      
        if(21 <= taskA_Num)
        {
             LED0 = 1;
             NVIC_InitStructure.NVIC_IRQChannel=TIM3_IRQn; //ʱ3ж
             NVIC_InitStructure.NVIC_IRQChannelCmd=DISABLE;
	         NVIC_Init(&NVIC_InitStructure);
             OSTaskSuspend(LEDA_TASK_PRIO);//С˸10κ󣬹A         
        } 
	}
}

/********************B****************************
1. BС10HzƵ˸
2. BС˸20ιB𣬸Cź
*************************************************************/
void ledB_task(void *pdata)
{
    pdata=pdata;
    u8 taskB_Num = 0 ;//¼AС˸
	while(1)
	{
		LED1 = 0;
		delay_ms(50);
		LED1 = 1;
		delay_ms(50);
        taskB_Num++;     
        if(20 <= taskB_Num)
        {
          OSSemPost(sem_TaskC);//Cź
          OSTaskSuspend(LEDB_TASK_PRIO);//С˸20κ󣬹B        
        }
	}
}

/********************C****************************
1. CյBźʱCִ
2. ⲿжϵĴмͨ䷢͸C
3. жϴС5ʱCС1HzƵ˸
   жϴڵ5С10ʱCС10HzƵ˸
4. Cͨյ
*************************************************************/
void ledC_task(void *pdata)
{
    pdata=pdata;
    u8 err; 
    while (1)
    {
        OSSemPend(sem_TaskC, 0, &err);  //ź
        I3_Num = (u16* )OSMboxPend(msg_TaskC, 10, &err);   //
        if (I3_Num != NULL) //ϢûϢؿָ롣
        {
            I3_InNum = *I3_Num;
            OSQPost(q_Msg, I3_Num); //ͶϢ
         }
        if (I3_InNum < 5)
        {
            LED2 = 0;
            delay_ms(500);
	        LED2 = 1;
	        delay_ms(500);  
        }
        else if (I3_InNum >= 5 && I3_InNum < 10)
        {
            LED2 = 0;
            delay_ms(50);
	        LED2 = 1;
	        delay_ms(50);
        }
        OSSemPost(sem_TaskC);
  }
}

/********************D****************************
1DȡʱDСƳδȡʱDСƳ
2ⲿ1ΪߵƽʱDԻȡ
   ⲿ1Ϊ͵ƽʱDͷŻ
*************************************************************/
void ledD_task(void *pdata)
{
    pdata=pdata;
    u8 err;
	while(1)
	{
       if (KEY0 == 0)   //ⲿ1(PI_15)ΪߵƽԻȡź
       {
           OSMutexPend(sem_Mutex, 10, &err);
           if (err != 10u)
           {
             LED3 = 0;
           }     
       }
       if (KEY0 == 1)   //ⲿ1Ϊ͵ƽͷŻź
       {
           OSMutexPost(sem_Mutex);
           LED3 = 1;
           
       }
       delay_ms(10);   //   
	}
}

/********************E****************************
1EȡʱEСƳδȡʱEСƳ
2ⲿ2ΪߵƽʱEԻȡ
   ⲿ2Ϊ͵ƽʱEͷŻ
*************************************************************/
void ledE_task(void *pdata)
{
    pdata=pdata;
    u8 err;
	while(1)
	{                       
        if (KEY1 == 0)   //ⲿ2ΪߵƽԻȡź
        {
            OSMutexPend(sem_Mutex, 10, &err);    
            if (err != 10u)
            {
                 LED4 = 0;
            }
        }
        if (KEY1 == 1)   //ⲿ2Ϊ͵ƽͷŻź
        {
            OSMutexPost(sem_Mutex);
            LED4 = 1;
        }
        delay_ms(10);     
	}
}

/********************F****************************
1EȡʱEСƳδȡʱEСƳ
2ⲿ2ΪߵƽʱEԻȡ
   ⲿ2Ϊ͵ƽʱEͷŻ
*************************************************************/
void ledF_task(void *pdata)
{
    pdata=pdata;
    u8 err;
    u8 num;
    u8 *p;
	while(1)
	{
        p = OSQPend(q_Msg, 0, &err);  //Ϣ
        if (p != NULL)
        {
            num = *p % 8;
        }
        switch (num)
        {
            case 0:
                LED5 = 1; LED6 = 1; LED7 = 1; LED8 = 1; LED9 = 1; LED10 = 1; LED11 = 1; 
                LED12 = 1; LED13 = 1; LED14 = 1; LED15 = 1;
                break;
            case 1:
                LED5 = 0; LED6 = 1; LED7 = 1; LED8 = 1; LED9 = 1; LED10 = 1; LED11 = 1; 
                LED12 = 1; LED13 = 1; LED14 = 1; LED15 = 1;
                break;
            case 2:
                LED5 = 0; LED6 = 0; LED7 = 1; LED8 = 1; LED9 = 1; LED10 = 1; LED11 = 1; 
                LED12 = 1; LED13 = 1; LED14 = 1; LED15 = 1;
                break;
            case 3:
                LED5 = 0; LED6 = 0; LED7 = 0; LED8 = 1; LED9 = 1; LED10 = 1; LED11 = 1; 
                LED12 = 1; LED13 = 1; LED14 = 1; LED15 = 1;
                break;
            case 4:
                LED5 = 0; LED6 = 0; LED7 = 0; LED8 = 0; LED9 = 1; LED10 = 1; LED11 = 1; 
                LED12 = 1; LED13 = 1; LED14 = 1; LED15 = 1;
                break;
            case 5:
                LED5 = 0; LED6 = 0; LED7 = 0; LED8 = 0; LED9 = 0; LED10 = 1; LED11 = 1; 
                LED12 = 1; LED13 = 1; LED14 = 1; LED15 = 1;
                break;
            case 6:
                LED5 = 0; LED6 = 0; LED7 = 0; LED8 = 0; LED9 = 0; LED10 = 0; LED11 = 1; 
                LED12 = 1; LED13 = 1; LED14 = 1; LED15 = 1;
                break;
            case 7:
                LED5 = 0; LED6 = 0; LED7 = 0; LED8 = 0; LED9 = 0; LED10 = 0; LED11 = 0; 
                LED12 = 1; LED13 = 1; LED14 = 1; LED15 = 1;
                break;
            case 8:
                LED5 = 0; LED6 = 0; LED7 = 0; LED8 = 0; LED9 = 0; LED10 = 0; LED11 = 0; 
                LED12 = 0; LED13 = 1; LED14 = 1; LED15 = 1;
                break;
            case 9:
                LED5 = 0; LED6 = 0; LED7 = 0; LED8 = 0; LED9 = 0; LED10 = 0; LED11 = 0; 
                LED12 = 0; LED13 = 0; LED14 = 1; LED15 = 1;
                break;
            case 10:
                LED5 = 0; LED6 = 0; LED7 = 0; LED8 = 0; LED9 = 0; LED10 = 0; LED11 = 0; 
                LED12 = 0; LED13 = 0; LED14 = 0; LED15 = 1;
                break;
            case 11:
                LED5 = 0; LED6 = 0; LED7 = 0; LED8 = 0; LED9 = 0; LED10 = 0; LED11 = 0; 
                LED12 = 0; LED13 = 0; LED14 = 0; LED15 = 0;
                break;
            default:
                LED5 = 0; LED6 = 0; LED7 = 0; LED8 = 0; LED9 = 0; LED10 = 0; LED11 = 0; 
                LED12 = 0; LED13 = 0; LED14 = 0; LED15 = 0;
                break;
        }
        delay_ms(20);   //
	}
}



//
void keyG_task(void *pdata)
{
    pdata=pdata;
    NVIC_InitTypeDef   NVIC_InitStructure;
    while (1)
    {
        if (flag_Exit == 1)
        { 
            NVIC_InitStructure.NVIC_IRQChannel = EXTI4_IRQn;//ⲿж4
            NVIC_InitStructure.NVIC_IRQChannelCmd = DISABLE;//ʹⲿжͨ
            NVIC_Init(&NVIC_InitStructure);//           
            PB4_Num++;
            OSMboxPost(msg_TaskC, &PB4_Num);  //Ϣ
            delay_ms(500);    
            NVIC_InitStructure.NVIC_IRQChannel = EXTI4_IRQn;//ⲿж4
            NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;//ʹⲿжͨ
            NVIC_Init(&NVIC_InitStructure);//  
            flag_Exit = 0;
        }
    }
    
}

//ⲿж4---PB4½ش
//жϷܵÿܻᵼȵĺ
void EXTI4_IRQHandler(void)
{
    
    OSIntEnter(); //жϴ
    flag_Exit = 1;
    EXTI_ClearITPendingBit(EXTI_Line4);//LINE4ϵжϱ־λ  
     
    OSIntExit();   //˳жϴ
}


//ʱ3жϷ
void TIM3_IRQHandler(void)
{
    OSIntEnter(); //жϴ
	if(TIM_GetITStatus(TIM3,TIM_IT_Update)==SET) //ж
	{
		LED0=!LED0;//LED0ת
        taskA_Num++;
	}
	TIM_ClearITPendingBit(TIM3,TIM_IT_Update);  //жϱ־λ
    OSIntExit();   //˳жϴ
}








